diff --git a/external/fmt/test/ostream-test.cc b/external/fmt/test/ostream-test.cc
index 1c87d46d..f81039e5 100644
--- a/external/fmt/test/ostream-test.cc
+++ b/external/fmt/test/ostream-test.cc
@@ -5,17 +5,17 @@
 //
 // For the license information refer to format.h.
 
-#define FMT_STRING_ALIAS 1
 #include "fmt/format.h"
 
+using fmt::runtime;
+
 struct test {};
 
 // Test that there is no issues with specializations when fmt/ostream.h is
 // included after fmt/format.h.
 namespace fmt {
 template <> struct formatter<test> : formatter<int> {
-  template <typename FormatContext>
-  typename FormatContext::iterator format(const test&, FormatContext& ctx) {
+  auto format(const test&, format_context& ctx) -> decltype(ctx.out()) {
     return formatter<int>::format(42, ctx);
   }
 };
@@ -23,20 +23,19 @@ template <> struct formatter<test> : formatter<int> {
 
 #include <sstream>
 
+#include "fmt/compile.h"
 #include "fmt/ostream.h"
-#include "gmock.h"
+#include "fmt/ranges.h"
+#include "gmock/gmock.h"
 #include "gtest-extra.h"
 #include "util.h"
 
-using fmt::format;
-using fmt::format_error;
-
-static std::ostream& operator<<(std::ostream& os, const Date& d) {
+std::ostream& operator<<(std::ostream& os, const date& d) {
   os << d.year() << '-' << d.month() << '-' << d.day();
   return os;
 }
 
-static std::wostream& operator<<(std::wostream& os, const Date& d) {
+std::wostream& operator<<(std::wostream& os, const date& d) {
   os << d.year() << L'-' << d.month() << L'-' << d.day();
   return os;
 }
@@ -44,99 +43,63 @@ static std::wostream& operator<<(std::wostream& os, const Date& d) {
 // Make sure that overloaded comma operators do no harm to is_streamable.
 struct type_with_comma_op {};
 template <typename T> void operator,(type_with_comma_op, const T&);
-template <typename T> type_with_comma_op operator<<(T&, const Date&);
+template <typename T> type_with_comma_op operator<<(T&, const date&);
 
 enum streamable_enum {};
-static std::ostream& operator<<(std::ostream& os, streamable_enum) {
-  return os << "streamable_enum";
-}
 
-static std::wostream& operator<<(std::wostream& os, streamable_enum) {
-  return os << L"streamable_enum";
+std::ostream& operator<<(std::ostream& os, streamable_enum) {
+  return os << "streamable_enum";
 }
 
 enum unstreamable_enum {};
 
-TEST(OStreamTest, Enum) {
+TEST(ostream_test, enum) {
   EXPECT_EQ("streamable_enum", fmt::format("{}", streamable_enum()));
   EXPECT_EQ("0", fmt::format("{}", unstreamable_enum()));
-  EXPECT_EQ(L"streamable_enum", fmt::format(L"{}", streamable_enum()));
-  EXPECT_EQ(L"0", fmt::format(L"{}", unstreamable_enum()));
-}
-
-struct test_arg_formatter
-    : fmt::detail::arg_formatter<fmt::format_context::iterator, char> {
-  fmt::format_parse_context parse_ctx;
-  test_arg_formatter(fmt::format_context& ctx, fmt::format_specs& s)
-      : fmt::detail::arg_formatter<fmt::format_context::iterator, char>(
-            ctx, &parse_ctx, &s),
-        parse_ctx("") {}
-};
-
-TEST(OStreamTest, CustomArg) {
-  fmt::memory_buffer buffer;
-  fmt::detail::buffer<char>& base = buffer;
-  fmt::format_context ctx(std::back_inserter(base), fmt::format_args());
-  fmt::format_specs spec;
-  test_arg_formatter af(ctx, spec);
-  fmt::visit_format_arg(
-      af, fmt::detail::make_arg<fmt::format_context>(streamable_enum()));
-  EXPECT_EQ("streamable_enum", std::string(buffer.data(), buffer.size()));
 }
 
-TEST(OStreamTest, Format) {
-  EXPECT_EQ("a string", format("{0}", TestString("a string")));
-  std::string s = format("The date is {0}", Date(2012, 12, 9));
-  EXPECT_EQ("The date is 2012-12-9", s);
-  Date date(2012, 12, 9);
-  EXPECT_EQ(L"The date is 2012-12-9",
-            format(L"The date is {0}", Date(2012, 12, 9)));
+TEST(ostream_test, format) {
+  EXPECT_EQ("a string", fmt::format("{0}", test_string("a string")));
+  EXPECT_EQ("The date is 2012-12-9",
+            fmt::format("The date is {0}", date(2012, 12, 9)));
 }
 
-TEST(OStreamTest, FormatSpecs) {
-  EXPECT_EQ("def  ", format("{0:<5}", TestString("def")));
-  EXPECT_EQ("  def", format("{0:>5}", TestString("def")));
-#if FMT_DEPRECATED_NUMERIC_ALIGN
-  EXPECT_THROW_MSG(format("{0:=5}", TestString("def")), format_error,
-                   "format specifier requires numeric argument");
-#endif
-  EXPECT_EQ(" def ", format("{0:^5}", TestString("def")));
-  EXPECT_EQ("def**", format("{0:*<5}", TestString("def")));
-  EXPECT_THROW_MSG(format("{0:+}", TestString()), format_error,
-                   "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{0:-}", TestString()), format_error,
-                   "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{0: }", TestString()), format_error,
-                   "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{0:#}", TestString()), format_error,
-                   "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{0:05}", TestString()), format_error,
-                   "format specifier requires numeric argument");
-  EXPECT_EQ("test         ", format("{0:13}", TestString("test")));
-  EXPECT_EQ("test         ", format("{0:{1}}", TestString("test"), 13));
-  EXPECT_EQ("te", format("{0:.2}", TestString("test")));
-  EXPECT_EQ("te", format("{0:.{1}}", TestString("test"), 2));
+TEST(ostream_test, format_specs) {
+  using fmt::format_error;
+  EXPECT_EQ("def  ", fmt::format("{0:<5}", test_string("def")));
+  EXPECT_EQ("  def", fmt::format("{0:>5}", test_string("def")));
+  EXPECT_EQ(" def ", fmt::format("{0:^5}", test_string("def")));
+  EXPECT_EQ("def**", fmt::format("{0:*<5}", test_string("def")));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:+}"), test_string()),
+                   format_error, "format specifier requires numeric argument");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:-}"), test_string()),
+                   format_error, "format specifier requires numeric argument");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0: }"), test_string()),
+                   format_error, "format specifier requires numeric argument");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:#}"), test_string()),
+                   format_error, "format specifier requires numeric argument");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:05}"), test_string()),
+                   format_error, "format specifier requires numeric argument");
+  EXPECT_EQ("test         ", fmt::format("{0:13}", test_string("test")));
+  EXPECT_EQ("test         ", fmt::format("{0:{1}}", test_string("test"), 13));
+  EXPECT_EQ("te", fmt::format("{0:.2}", test_string("test")));
+  EXPECT_EQ("te", fmt::format("{0:.{1}}", test_string("test"), 2));
 }
 
-struct EmptyTest {};
-static std::ostream& operator<<(std::ostream& os, EmptyTest) {
-  return os << "";
-}
+struct empty_test {};
+std::ostream& operator<<(std::ostream& os, empty_test) { return os << ""; }
 
-TEST(OStreamTest, EmptyCustomOutput) {
-  EXPECT_EQ("", fmt::format("{}", EmptyTest()));
+TEST(ostream_test, empty_custom_output) {
+  EXPECT_EQ("", fmt::format("{}", empty_test()));
 }
 
-TEST(OStreamTest, Print) {
+TEST(ostream_test, print) {
   std::ostringstream os;
   fmt::print(os, "Don't {}!", "panic");
   EXPECT_EQ("Don't panic!", os.str());
-  std::wostringstream wos;
-  fmt::print(wos, L"Don't {}!", L"panic");
-  EXPECT_EQ(L"Don't panic!", wos.str());
 }
 
-TEST(OStreamTest, WriteToOStream) {
+TEST(ostream_test, write_to_ostream) {
   std::ostringstream os;
   fmt::memory_buffer buffer;
   const char* foo = "foo";
@@ -145,31 +108,33 @@ TEST(OStreamTest, WriteToOStream) {
   EXPECT_EQ("foo", os.str());
 }
 
-TEST(OStreamTest, WriteToOStreamMaxSize) {
-  size_t max_size = fmt::detail::max_value<size_t>();
-  std::streamsize max_streamsize = fmt::detail::max_value<std::streamsize>();
+TEST(ostream_test, write_to_ostream_max_size) {
+  auto max_size = fmt::detail::max_value<size_t>();
+  auto max_streamsize = fmt::detail::max_value<std::streamsize>();
   if (max_size <= fmt::detail::to_unsigned(max_streamsize)) return;
 
-  struct test_buffer : fmt::detail::buffer<char> {
-    explicit test_buffer(size_t size) { resize(size); }
-    void grow(size_t) {}
+  struct test_buffer final : fmt::detail::buffer<char> {
+    explicit test_buffer(size_t size)
+        : fmt::detail::buffer<char>(nullptr, size, size) {}
+    void grow(size_t) override {}
   } buffer(max_size);
 
   struct mock_streambuf : std::streambuf {
     MOCK_METHOD2(xsputn, std::streamsize(const void* s, std::streamsize n));
-    std::streamsize xsputn(const char* s, std::streamsize n) {
+    std::streamsize xsputn(const char* s, std::streamsize n) override {
       const void* v = s;
       return xsputn(v, n);
     }
   } streambuf;
 
   struct test_ostream : std::ostream {
-    explicit test_ostream(mock_streambuf& buffer) : std::ostream(&buffer) {}
+    explicit test_ostream(mock_streambuf& output_buffer)
+        : std::ostream(&output_buffer) {}
   } os(streambuf);
 
   testing::InSequence sequence;
   const char* data = nullptr;
-  typedef std::make_unsigned<std::streamsize>::type ustreamsize;
+  using ustreamsize = std::make_unsigned<std::streamsize>::type;
   ustreamsize size = max_size;
   do {
     auto n = std::min(size, fmt::detail::to_unsigned(max_streamsize));
@@ -181,68 +146,62 @@ TEST(OStreamTest, WriteToOStreamMaxSize) {
   fmt::detail::write_buffer(os, buffer);
 }
 
-TEST(OStreamTest, Join) {
+TEST(ostream_test, join) {
   int v[3] = {1, 2, 3};
   EXPECT_EQ("1, 2, 3", fmt::format("{}", fmt::join(v, v + 3, ", ")));
 }
 
+TEST(ostream_test, join_fallback_formatter) {
+  auto strs = std::vector<test_string>{test_string("foo"), test_string("bar")};
+  EXPECT_EQ("foo, bar", fmt::format("{}", fmt::join(strs, ", ")));
+}
+
 #if FMT_USE_CONSTEXPR
-TEST(OStreamTest, ConstexprString) {
+TEST(ostream_test, constexpr_string) {
   EXPECT_EQ("42", format(FMT_STRING("{}"), std::string("42")));
-  EXPECT_EQ("a string", format(FMT_STRING("{0}"), TestString("a string")));
+  EXPECT_EQ("a string", format(FMT_STRING("{0}"), test_string("a string")));
 }
 #endif
 
 namespace fmt_test {
-struct ABC {};
+struct abc {};
 
-template <typename Output> Output& operator<<(Output& out, ABC) {
-  out << "ABC";
-  return out;
+template <typename Output> Output& operator<<(Output& out, abc) {
+  return out << "abc";
 }
 }  // namespace fmt_test
 
-template <typename T> struct TestTemplate {};
+template <typename T> struct test_template {};
 
 template <typename T>
-std::ostream& operator<<(std::ostream& os, TestTemplate<T>) {
+std::ostream& operator<<(std::ostream& os, test_template<T>) {
   return os << 1;
 }
 
 namespace fmt {
-template <typename T> struct formatter<TestTemplate<T>> : formatter<int> {
-  template <typename FormatContext>
-  typename FormatContext::iterator format(TestTemplate<T>, FormatContext& ctx) {
+template <typename T> struct formatter<test_template<T>> : formatter<int> {
+  auto format(test_template<T>, format_context& ctx) -> decltype(ctx.out()) {
     return formatter<int>::format(2, ctx);
   }
 };
 }  // namespace fmt
 
-#if !FMT_GCC_VERSION || FMT_GCC_VERSION >= 407
-TEST(OStreamTest, Template) {
-  EXPECT_EQ("2", fmt::format("{}", TestTemplate<int>()));
+TEST(ostream_test, template) {
+  EXPECT_EQ("2", fmt::format("{}", test_template<int>()));
 }
 
-TEST(FormatTest, FormatToN) {
+TEST(ostream_test, format_to_n) {
   char buffer[4];
   buffer[3] = 'x';
-  auto result = fmt::format_to_n(buffer, 3, "{}", fmt_test::ABC());
+  auto result = fmt::format_to_n(buffer, 3, "{}", fmt_test::abc());
   EXPECT_EQ(3u, result.size);
   EXPECT_EQ(buffer + 3, result.out);
-  EXPECT_EQ("ABCx", fmt::string_view(buffer, 4));
-  result = fmt::format_to_n(buffer, 3, "x{}y", fmt_test::ABC());
+  EXPECT_EQ("abcx", fmt::string_view(buffer, 4));
+  result = fmt::format_to_n(buffer, 3, "x{}y", fmt_test::abc());
   EXPECT_EQ(5u, result.size);
   EXPECT_EQ(buffer + 3, result.out);
-  EXPECT_EQ("xABx", fmt::string_view(buffer, 4));
+  EXPECT_EQ("xabx", fmt::string_view(buffer, 4));
 }
-#endif
-
-#if FMT_USE_USER_DEFINED_LITERALS
-TEST(FormatTest, UDL) {
-  using namespace fmt::literals;
-  EXPECT_EQ("{}"_format("test"), "test");
-}
-#endif
 
 template <typename T> struct convertible {
   T value;
@@ -250,9 +209,8 @@ template <typename T> struct convertible {
   operator T() const { return value; }
 };
 
-TEST(OStreamTest, DisableBuiltinOStreamOperators) {
+TEST(ostream_test, disable_builtin_ostream_operators) {
   EXPECT_EQ("42", fmt::format("{:d}", convertible<unsigned short>(42)));
-  EXPECT_EQ(L"42", fmt::format(L"{:d}", convertible<unsigned short>(42)));
   EXPECT_EQ("foo", fmt::format("{}", convertible<const char*>("foo")));
 }
 
@@ -270,7 +228,7 @@ std::ostream& operator<<(std::ostream& os,
   return os << "bar";
 }
 
-TEST(OStreamTest, FormatExplicitlyConvertibleToStringLike) {
+TEST(ostream_test, format_explicitly_convertible_to_string_like) {
   EXPECT_EQ("bar", fmt::format("{}", explicitly_convertible_to_string_like()));
 }
 
@@ -286,12 +244,24 @@ std::ostream& operator<<(std::ostream& os,
   return os << "bar";
 }
 
-TEST(OStreamTest, FormatExplicitlyConvertibleToStdStringView) {
+TEST(ostream_test, format_explicitly_convertible_to_std_string_view) {
   EXPECT_EQ("bar", fmt::format("{}", explicitly_convertible_to_string_like()));
 }
-
 #endif  // FMT_USE_STRING_VIEW
 
+struct streamable_and_convertible_to_bool {
+  operator bool() const { return true; }
+};
+
+std::ostream& operator<<(std::ostream& os, streamable_and_convertible_to_bool) {
+  return os << "foo";
+}
+
+TEST(ostream_test, format_convertible_to_bool) {
+  // operator<< is intentionally not used because of potential ODR violations.
+  EXPECT_EQ(fmt::format("{}", streamable_and_convertible_to_bool()), "true");
+}
+
 struct copyfmt_test {};
 
 std::ostream& operator<<(std::ostream& os, copyfmt_test) {
@@ -300,10 +270,32 @@ std::ostream& operator<<(std::ostream& os, copyfmt_test) {
   return os << "foo";
 }
 
-TEST(OStreamTest, CopyFmt) {
+TEST(ostream_test, copyfmt) {
   EXPECT_EQ("foo", fmt::format("{}", copyfmt_test()));
 }
 
-TEST(OStreamTest, CompileTimeString) {
-  EXPECT_EQ("42", fmt::format(FMT_STRING("{}"), 42));
+TEST(ostream_test, to_string) {
+  EXPECT_EQ("abc", fmt::to_string(fmt_test::abc()));
+}
+
+TEST(ostream_test, range) {
+  auto strs = std::vector<test_string>{test_string("foo"), test_string("bar")};
+  EXPECT_EQ("[foo, bar]", fmt::format("{}", strs));
+}
+
+struct abstract {
+  virtual ~abstract() = default;
+  virtual void f() = 0;
+  friend std::ostream& operator<<(std::ostream& os, const abstract&) {
+    return os;
+  }
+};
+
+void format_abstract_compiles(const abstract& a) {
+  fmt::format(FMT_COMPILE("{}"), a);
+}
+
+TEST(ostream_test, is_formattable) {
+  EXPECT_TRUE(fmt::is_formattable<std::string>());
+  EXPECT_TRUE(fmt::is_formattable<fmt::detail::std_string_view<char>>());
 }
diff --git a/external/fmt/test/posix-mock-test.cc b/external/fmt/test/posix-mock-test.cc
index eb85756d..255e216c 100644
--- a/external/fmt/test/posix-mock-test.cc
+++ b/external/fmt/test/posix-mock-test.cc
@@ -23,20 +23,23 @@
 #ifdef _WIN32
 #  include <io.h>
 #  undef max
-#  undef ERROR
 #endif
 
-#include "gmock.h"
+#include "gmock/gmock.h"
 #include "gtest-extra.h"
 #include "util.h"
 
 using fmt::buffered_file;
-using fmt::error_code;
 
 using testing::_;
 using testing::Return;
 using testing::StrEq;
 
+template <typename Mock> struct scoped_mock : testing::StrictMock<Mock> {
+  scoped_mock() { Mock::instance = this; }
+  ~scoped_mock() { Mock::instance = nullptr; }
+};
+
 namespace {
 int open_count;
 int close_count;
@@ -53,7 +56,7 @@ size_t read_nbyte;
 size_t write_nbyte;
 bool sysconf_error;
 
-enum { NONE, MAX_SIZE, ERROR } fstat_sim;
+enum { none, max_size, error } fstat_sim;
 }  // namespace
 
 #define EMULATE_EINTR(func, error_result) \
@@ -91,7 +94,7 @@ static off_t max_file_size() { return std::numeric_limits<off_t>::max(); }
 
 int test::fstat(int fd, struct stat* buf) {
   int result = ::fstat(fd, buf);
-  if (fstat_sim == MAX_SIZE) buf->st_size = max_file_size();
+  if (fstat_sim == max_size) buf->st_size = max_file_size();
   return result;
 }
 
@@ -100,11 +103,11 @@ int test::fstat(int fd, struct stat* buf) {
 static LONGLONG max_file_size() { return std::numeric_limits<LONGLONG>::max(); }
 
 DWORD test::GetFileSize(HANDLE hFile, LPDWORD lpFileSizeHigh) {
-  if (fstat_sim == ERROR) {
+  if (fstat_sim == error) {
     SetLastError(ERROR_ACCESS_DENIED);
     return INVALID_FILE_SIZE;
   }
-  if (fstat_sim == MAX_SIZE) {
+  if (fstat_sim == max_size) {
     DWORD max = std::numeric_limits<DWORD>::max();
     *lpFileSizeHigh = max >> 1;
     return max;
@@ -194,15 +197,15 @@ int(test::fileno)(FILE* stream) {
 #  define EXPECT_EQ_POSIX(expected, actual)
 #endif
 
-static void write_file(fmt::cstring_view filename, fmt::string_view content) {
+#if FMT_USE_FCNTL
+void write_file(fmt::cstring_view filename, fmt::string_view content) {
   fmt::buffered_file f(filename, "w");
   f.print("{}", content);
 }
 
-#if FMT_USE_FCNTL
 using fmt::file;
 
-TEST(UtilTest, GetPageSize) {
+TEST(os_test, getpagesize) {
 #  ifdef _WIN32
   SYSTEM_INFO si = {};
   GetSystemInfo(&si);
@@ -216,7 +219,7 @@ TEST(UtilTest, GetPageSize) {
 #  endif
 }
 
-TEST(FileTest, OpenRetry) {
+TEST(file_test, open_retry) {
   write_file("temp", "there must be something here");
   std::unique_ptr<file> f{nullptr};
   EXPECT_RETRY(f.reset(new file("temp", file::RDONLY)), open,
@@ -227,7 +230,7 @@ TEST(FileTest, OpenRetry) {
 #  endif
 }
 
-TEST(FileTest, CloseNoRetryInDtor) {
+TEST(file_test, close_no_retry_in_dtor) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   std::unique_ptr<file> f(new file(std::move(read_end)));
@@ -240,11 +243,11 @@ TEST(FileTest, CloseNoRetryInDtor) {
         saved_close_count = close_count;
         close_count = 0;
       },
-      format_system_error(EINTR, "cannot close file") + "\n");
+      system_error_message(EINTR, "cannot close file") + "\n");
   EXPECT_EQ(2, saved_close_count);
 }
 
-TEST(FileTest, CloseNoRetry) {
+TEST(file_test, close_no_retry) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   close_count = 1;
@@ -253,35 +256,39 @@ TEST(FileTest, CloseNoRetry) {
   close_count = 0;
 }
 
-TEST(FileTest, Size) {
+TEST(file_test, size) {
   std::string content = "top secret, destroy before reading";
   write_file("temp", content);
   file f("temp", file::RDONLY);
   EXPECT_GE(f.size(), 0);
   EXPECT_EQ(content.size(), static_cast<unsigned long long>(f.size()));
 #  ifdef _WIN32
-  fmt::memory_buffer message;
-  fmt::detail::format_windows_error(message, ERROR_ACCESS_DENIED,
-                                    "cannot get file size");
-  fstat_sim = ERROR;
-  EXPECT_THROW_MSG(f.size(), fmt::windows_error, fmt::to_string(message));
-  fstat_sim = NONE;
+  auto error_code = std::error_code();
+  fstat_sim = error;
+  try {
+    f.size();
+  } catch (const std::system_error& e) {
+    error_code = e.code();
+  }
+  fstat_sim = none;
+  EXPECT_EQ(error_code,
+            std::error_code(ERROR_ACCESS_DENIED, fmt::system_category()));
 #  else
   f.close();
   EXPECT_SYSTEM_ERROR(f.size(), EBADF, "cannot get file attributes");
 #  endif
 }
 
-TEST(FileTest, MaxSize) {
+TEST(file_test, max_size) {
   write_file("temp", "");
   file f("temp", file::RDONLY);
-  fstat_sim = MAX_SIZE;
+  fstat_sim = max_size;
   EXPECT_GE(f.size(), 0);
   EXPECT_EQ(max_file_size(), f.size());
-  fstat_sim = NONE;
+  fstat_sim = none;
 }
 
-TEST(FileTest, ReadRetry) {
+TEST(file_test, read_retry) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   enum { SIZE = 4 };
@@ -294,7 +301,7 @@ TEST(FileTest, ReadRetry) {
   EXPECT_EQ_POSIX(static_cast<std::streamsize>(SIZE), count);
 }
 
-TEST(FileTest, WriteRetry) {
+TEST(file_test, write_retry) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   enum { SIZE = 4 };
@@ -312,7 +319,7 @@ TEST(FileTest, WriteRetry) {
 }
 
 #  ifdef _WIN32
-TEST(FileTest, ConvertReadCount) {
+TEST(file_test, convert_read_count) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   char c;
@@ -320,12 +327,12 @@ TEST(FileTest, ConvertReadCount) {
   if (sizeof(unsigned) != sizeof(size_t)) ++size;
   read_count = 1;
   read_nbyte = 0;
-  EXPECT_THROW(read_end.read(&c, size), fmt::system_error);
+  EXPECT_THROW(read_end.read(&c, size), std::system_error);
   read_count = 0;
   EXPECT_EQ(UINT_MAX, read_nbyte);
 }
 
-TEST(FileTest, ConvertWriteCount) {
+TEST(file_test, convert_write_count) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   char c;
@@ -333,13 +340,13 @@ TEST(FileTest, ConvertWriteCount) {
   if (sizeof(unsigned) != sizeof(size_t)) ++size;
   write_count = 1;
   write_nbyte = 0;
-  EXPECT_THROW(write_end.write(&c, size), fmt::system_error);
+  EXPECT_THROW(write_end.write(&c, size), std::system_error);
   write_count = 0;
   EXPECT_EQ(UINT_MAX, write_nbyte);
 }
 #  endif
 
-TEST(FileTest, DupNoRetry) {
+TEST(file_test, dup_no_retry) {
   int stdout_fd = FMT_POSIX(fileno(stdout));
   dup_count = 1;
   EXPECT_SYSTEM_ERROR(
@@ -348,7 +355,7 @@ TEST(FileTest, DupNoRetry) {
   dup_count = 0;
 }
 
-TEST(FileTest, Dup2Retry) {
+TEST(file_test, dup2_retry) {
   int stdout_fd = FMT_POSIX(fileno(stdout));
   file f1 = file::dup(stdout_fd), f2 = file::dup(stdout_fd);
   EXPECT_RETRY(f1.dup2(f2.descriptor()), dup2,
@@ -356,21 +363,21 @@ TEST(FileTest, Dup2Retry) {
                            f1.descriptor(), f2.descriptor()));
 }
 
-TEST(FileTest, Dup2NoExceptRetry) {
+TEST(file_test, dup2_no_except_retry) {
   int stdout_fd = FMT_POSIX(fileno(stdout));
   file f1 = file::dup(stdout_fd), f2 = file::dup(stdout_fd);
-  error_code ec;
+  std::error_code ec;
   dup2_count = 1;
   f1.dup2(f2.descriptor(), ec);
 #  ifndef _WIN32
   EXPECT_EQ(4, dup2_count);
 #  else
-  EXPECT_EQ(EINTR, ec.get());
+  EXPECT_EQ(EINTR, ec.value());
 #  endif
   dup2_count = 0;
 }
 
-TEST(FileTest, PipeNoRetry) {
+TEST(file_test, pipe_no_retry) {
   file read_end, write_end;
   pipe_count = 1;
   EXPECT_SYSTEM_ERROR(file::pipe(read_end, write_end), EINTR,
@@ -378,7 +385,7 @@ TEST(FileTest, PipeNoRetry) {
   pipe_count = 0;
 }
 
-TEST(FileTest, FdopenNoRetry) {
+TEST(file_test, fdopen_no_retry) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   fdopen_count = 1;
@@ -387,7 +394,7 @@ TEST(FileTest, FdopenNoRetry) {
   fdopen_count = 0;
 }
 
-TEST(BufferedFileTest, OpenRetry) {
+TEST(buffered_file_test, open_retry) {
   write_file("temp", "there must be something here");
   std::unique_ptr<buffered_file> f{nullptr};
   EXPECT_RETRY(f.reset(new buffered_file("temp", "r")), fopen,
@@ -399,7 +406,7 @@ TEST(BufferedFileTest, OpenRetry) {
 #  endif
 }
 
-TEST(BufferedFileTest, CloseNoRetryInDtor) {
+TEST(buffered_file_test, close_no_retry_in_dtor) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   std::unique_ptr<buffered_file> f(new buffered_file(read_end.fdopen("r")));
@@ -412,11 +419,11 @@ TEST(BufferedFileTest, CloseNoRetryInDtor) {
         saved_fclose_count = fclose_count;
         fclose_count = 0;
       },
-      format_system_error(EINTR, "cannot close file") + "\n");
+      system_error_message(EINTR, "cannot close file") + "\n");
   EXPECT_EQ(2, saved_fclose_count);
 }
 
-TEST(BufferedFileTest, CloseNoRetry) {
+TEST(buffered_file_test, close_no_retry) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   buffered_file f = read_end.fdopen("r");
@@ -426,7 +433,7 @@ TEST(BufferedFileTest, CloseNoRetry) {
   fclose_count = 0;
 }
 
-TEST(BufferedFileTest, FilenoNoRetry) {
+TEST(buffered_file_test, fileno_no_retry) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   buffered_file f = read_end.fdopen("r");
@@ -441,9 +448,9 @@ struct test_mock {
   static test_mock* instance;
 } * test_mock::instance;
 
-TEST(ScopedMock, Scope) {
+TEST(scoped_mock, scope) {
   {
-    ScopedMock<test_mock> mock;
+    scoped_mock<test_mock> mock;
     EXPECT_EQ(&mock, test_mock::instance);
     test_mock& copy = mock;
     static_cast<void>(copy);
@@ -453,16 +460,13 @@ TEST(ScopedMock, Scope) {
 
 #ifdef FMT_LOCALE
 
-typedef fmt::locale::type locale_type;
+using locale_type = fmt::locale::type;
 
 struct locale_mock {
   static locale_mock* instance;
   MOCK_METHOD3(newlocale, locale_type(int category_mask, const char* locale,
                                       locale_type base));
   MOCK_METHOD1(freelocale, void(locale_type locale));
-
-  MOCK_METHOD3(strtod_l,
-               double(const char* nptr, char** endptr, locale_type locale));
 } * locale_mock::instance;
 
 #  ifdef _MSC_VER
@@ -480,17 +484,14 @@ _locale_t _create_locale(int category, const char* locale) {
 void _free_locale(_locale_t locale) {
   locale_mock::instance->freelocale(locale);
 }
-
-double _strtod_l(const char* nptr, char** endptr, _locale_t locale) {
-  return locale_mock::instance->strtod_l(nptr, endptr, locale);
-}
 #    ifdef __clang__
 #      pragma clang diagnostic pop
 #    endif
 #    pragma warning(pop)
 #  endif
 
-#  if defined(__THROW) && FMT_GCC_VERSION > 0 && FMT_GCC_VERSION <= 408
+#  if defined(__THROW) && \
+      ((FMT_GCC_VERSION > 0 && FMT_GCC_VERSION <= 408) || defined(__e2k__))
 #    define FMT_LOCALE_THROW __THROW
 #  else
 #    define FMT_LOCALE_THROW
@@ -508,11 +509,6 @@ FreeLocaleResult freelocale(locale_type locale) FMT_LOCALE_THROW {
   return FreeLocaleResult();
 }
 
-double strtod_l(const char* nptr, char** endptr,
-                locale_type locale) FMT_LOCALE_THROW {
-  return locale_mock::instance->strtod_l(nptr, endptr, locale);
-}
-
 #  undef FMT_LOCALE_THROW
 
 #  ifndef _WIN32
@@ -520,20 +516,20 @@ locale_t test::newlocale(int category_mask, const char* locale, locale_t base) {
   return locale_mock::instance->newlocale(category_mask, locale, base);
 }
 
-TEST(LocaleTest, LocaleMock) {
-  ScopedMock<locale_mock> mock;
-  locale_type locale = reinterpret_cast<locale_type>(11);
+TEST(locale_test, locale_mock) {
+  scoped_mock<locale_mock> mock;
+  auto locale = reinterpret_cast<locale_type>(11);
   EXPECT_CALL(mock, newlocale(222, StrEq("foo"), locale));
   FMT_SYSTEM(newlocale(222, "foo", locale));
 }
 #  endif
 
-TEST(LocaleTest, Locale) {
+TEST(locale_test, locale) {
 #  ifndef LC_NUMERIC_MASK
   enum { LC_NUMERIC_MASK = LC_NUMERIC };
 #  endif
-  ScopedMock<locale_mock> mock;
-  locale_type impl = reinterpret_cast<locale_type>(42);
+  scoped_mock<locale_mock> mock;
+  auto impl = reinterpret_cast<locale_type>(42);
   EXPECT_CALL(mock, newlocale(LC_NUMERIC_MASK, StrEq("C"), nullptr))
       .WillOnce(Return(impl));
   EXPECT_CALL(mock, freelocale(impl));
@@ -541,18 +537,4 @@ TEST(LocaleTest, Locale) {
   EXPECT_EQ(impl, loc.get());
 }
 
-TEST(LocaleTest, Strtod) {
-  ScopedMock<locale_mock> mock;
-  EXPECT_CALL(mock, newlocale(_, _, _))
-      .WillOnce(Return(reinterpret_cast<locale_type>(42)));
-  EXPECT_CALL(mock, freelocale(_));
-  fmt::locale loc;
-  const char* str = "4.2";
-  char end = 'x';
-  EXPECT_CALL(mock, strtod_l(str, _, loc.get()))
-      .WillOnce(testing::DoAll(testing::SetArgPointee<1>(&end), Return(777)));
-  EXPECT_EQ(777, loc.strtod(str));
-  EXPECT_EQ(&end, str);
-}
-
 #endif  // FMT_LOCALE
